      subroutine monte(isteps)
c performs isteps/particle metropolis monte carlo steps
      implicit real*8 (a-h,o-z)
      include 'syscon.cm'
      include 'caver.cm'
      include 'cunits.cm'
c clamps programmed by d. ceperley at nrcc, 1978.
      include 'syspec.cm'
      include 'blank.cm'
      include 'cewald.cm'
      dimension xnew(3)
      character*8 qn1,qn2,qn4

      if(jmcar.eq.0) then ! intialize bins for averages
        data jmcar,qn1,qn2/0,'accept','mc.pe.'/
        call setav(jmcar,qn1,ratio,1)
        call setav(jmcpe,qn2,uname(1),1)
        if(ifply.ne.0) call setav(jmcvbd,qn4,uname(1),1)
        data qn4/'vbondm'/
      endif

      if(ifbins.ne.0)call bining(cc(lxold+1))
c for charged systems intialize collective coordinates
      if(ifchrg.ne.0) call rok(cc(lxold+1),cc(lrok+1))

      do  ipass=1,isteps
      lx=lxold
      do  imove=1,natoms

      ibold=0
      call potofp(cc(lx+1),imove,vold,ibold,ipold,ifply,vbold)
c randomly dispace particles inside a cube
         do  l=1,ndim
           r=cc(lx+l)+tau*(rng()-.5)
c  enforce periodic boundary conditions on new point
           include 'pbc.h'
           xnew(l)=r
         enddo

c get potential energy at this new point
      ibnew=1
      call potofp(xnew,imove,vnew,ibnew,ipnew,ifply,vbnew)
      pexp=beta*(vold-vnew)
      prob=exp(min(0.0d0,max(-200.d0,pexp)))
      if(prob.gt.rng()) then
c accept move
           call accept(xnew,imove,ibold,ibnew,ipold)
           avtemp(jmcar)=avtemp(jmcar)+1.
       endif

       avtemp(jmcpe)=avtemp(jmcpe)+prob*(vnew-vold)+vold
      if(ifply.ne.0)avtemp(jmcvbd)=avtemp(jmcvbd)+
     +prob*(vbnew-vbold)+vbold

      lx=lx+ndim
       enddo
       call averages
      enddo

c  add to normalization of averages
      ant=float(isteps*natoms)
      anorm(jmcar)=anorm(jmcar)+ant
      anorm(jmcpe)=anorm(jmcpe)+2*ant
      if(ifply.ne.0) anorm(jmcvbd)=anorm(jmcvbd)+isteps*2
      return
      end
