      subroutine setbin(cutmx,ifpch,mnbin,mxbin)
      implicit real*8 (a-h,o-z)
      include 'blank.cm'
      include 'cbins.cm'
      include 'cewald.cm'
      include 'syspec.cm'
      include 'syscon.cm'
      real*8 dm(2)
      external second

c computes the number of bins to use by comparing the relative time taken
      data dm(1),dm(2)/1.d20,1.d20/
      write (*,*)' cutmx=',cutmx

      if(mxbin.lt.4) go to 80
      mnbin=max(mnbin,1)

c loop over k=number of divisions in x direction
      is=1

      write (6,225) mnbin,mxbin
225   format(/5x,' optimizing the number of bins'/5x,'search will be  ',
     +'between ',i5,' and',i5,' divisions in each direction')

      do 10 k=mnbin,mxbin
      if(k.gt.1) ifbins=1
      if(k.ge.4.or.k.eq.1) then

      do  l=1,ndim
         ndiv(l)=int(k*(ell(l)/ell(1))+.8)
         if(ifmd*mod(ndiv(l)+1,2).ne.0.and.el2(l).le.cutmx
     +      +ell(l)/ndiv(l)) go to 10
      enddo

c determine present usage of cache
      call caches(lstart,0,'setbin',2)
      if(k.gt.1) call binlst(cutmx,ifpch)

      call second(t0) ! get starting time
      if(ifmd.ne.0) then
         call force(lxold,vtotal,vbond)
      else
         ind=lxold+1
         if(k.gt.1) call bining(cc(ind))
         vtotal=0.0
         vbond=0.0
c intialize collective coordinates for charges
         if(ifchrg.ne.0) call rok(cc(lxold+1),cc(lrok+1))
         do  l=1,natoms
            ib=0
             call potofp(cc(ind),l,v,ib,ip,ifply,vb)
            vbond=vbond+vb
            ind=ind+ndim
            vtotal=vtotal+v
         enddo
         vtotal=vtotal*0.5d0
      endif

      call second(t1)
      if(k.gt.1) is=2
      df=t1-t0
      dm(is)=min(dm(is),df)
      write (6,325) (ndiv(l),l=1,ndim)
325   format(//5x,'examining the bin division ndiv(3)= ',3i5)
      write (6,326) nbins,nbors,df,vtotal
326   format(5x,' total number of bins ',i8,' number of neighboring',
     +' bins ',i5/5x,'cpu secs/step',e12.5,' potential energy ',e16.8)
      if(ifply.ne.0) write (6,89) vbond
89    format(20x,' bonding potential ',e12.5)
c free the memory used in bnlst
      call caches(lnow,0,'setbin',2)
      call caches(ldummy,lstart-lnow,'setbin',2)
      if(df.gt.dm(is)) go to 26
      kl=k

      endif
10    continue

26    continue
      if(dm(1).le.dm(2)) go to 80
           do l=1,ndim
             ndiv(l)=int(kl*(ell(l)/ell(1))+.8)
           enddo
200   ifbins=1
      call binlst(cutmx,ifpch)
      write (6,221) (ndiv(l),l=1,ndim)
221   format(/5x,' bin scheme used with divisions ',3i5)
      return
80    ifbins=0
      write (6,*)'bin scheme not used'
      nbins=0
      return
      end
